# $Id: test3.py 341 2007-04-25 11:58:48Z jcea $
#
# (c) 2006-2007 jcea@argo.es / jcea@hispasec.com
#
# PGP/GPG Public Key:
# pub   1024R/9AC53D4D 1995-01-01
#       Key fingerprint = F4 07 90 C2 58 86 8A 75  45 40 33 1C 72 4C E5 E1
# uid                  Jesus Cea Avion <jcea@hispasec.com>
# uid                  Jesus Cea Avion <jcea@argo.es>
#
# This product is covered by the GNU PUBLIC LICENSE, VERSION 2.
# For more detailt, read the file "LICENSE" in the distribution.


from durus.btree import BTree
from durus.connection import Connection
from berkeleydb_storage import BerkeleyDBStorage

connection = Connection(BerkeleyDBStorage("db",do_recover=False))

root=connection.get_root()
root[0]=BTree()
connection.commit()

for i in xrange(65536) :
  root[0][i]=0
connection.commit()

for i in xrange(0,65536,2) :
  del root[0][i]
connection.commit()

print len(root[0])

