# $Id: url_edit_grupos_POST.py 471 2007-11-08 22:37:42Z alvaro $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if usuario!="master" :
    return None

  if len(path)!=1 : return None

  import database

  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)

  usuarios=conn.get_root()["usuarios"]["usuarios"]
  grupos=conn.get_root()["grupos"]["grupos"]
  for num_grupo,grupo in grupos.items() :
    grupo_nuevo_nombre=cuerpo.getfirst("grupo%d" %num_grupo)
    grupo_nuevos_usuarios=cuerpo.getfirst("usuarios%d" %num_grupo)
    if grupo_nuevo_nombre==None or grupo_nuevos_usuarios==None : return None
    grupo_nuevo_nombre=grupo_nuevo_nombre.strip()
    if grupo_nuevo_nombre :
      grupo["nombre"]=grupo_nuevo_nombre
    if grupo_nuevos_usuarios :
      grupo_nuevos_usuarios=grupo_nuevos_usuarios.split(",")
    else :
      grupo_nuevos_usuarios=[]
    usuarios_pre=set()
    for i in grupo["usuarios"] :
      usuarios_pre.add(database.normaliza_nick(i))
    usuarios_post=set()
    for i in grupo_nuevos_usuarios :
      i2=i.strip()
      if i2=="" : i2=" <NO VALID> " # No puedes poner en un grupo al usuario anonimo...
      else : i2=database.normaliza_nick(i)
      if i2 not in usuarios :
        return (200, {"Content-Type":"text/html; charset=utf-8"},"El usuario '%s' no existe en el sistema" %i)
      usuarios_post.add(i2)
    if usuarios_pre!=usuarios_post :
      for i in usuarios_post-usuarios_pre :   # Usuarios nuevos
        database.grupo_add_user(conn,num_grupo,i)
      for i in usuarios_pre-usuarios_post :   # Usuarios borrados
        database.grupo_del_user(conn,num_grupo,i)
      grupo["usuarios"]=usuarios_post

  grupo_nuevo=cuerpo.getfirst("grupo_new")
  if grupo_nuevo==None : return None
  grupo_nuevo=grupo_nuevo.strip()
  if grupo_nuevo :
    if grupo_nuevo in grupos :
      return (200, {"Content-Type":"text/html; charset=utf-8"},"El grupo que se intenta crear ya existe")
    database.grupo_add(conn,grupo_nuevo)

  return (302,{"Location":"/"},"")

