# $Id: url_nuevo_post_POST.py 392 2007-10-15 17:26:16Z jcea $

from globales import monitor

import parsers # Doing here outside to avoid "monitor" deadlocks

def pagina_error(path,usuario,texto) :
  import skins
  pagina = skins.Skin(path,usuario)
  pagina.load_dict({"page_title": "Error"})
  pagina.load_url(["error"])
  pagina.load_dict({"generic_message": "<h1>%s</h1>" %texto})
  return pagina.web()

@monitor
def gestiona_url(conn,handler,path,usuario) :

  if len(path)!=3 : return None
  try :
    metatag=int(path[1])
    hilo=int(path[2])
  except :
    return None
  if not usuario : # Acceso anonimo
    return (302,{"Location":"/LOGIN/hilo/%d" % hilo}, "")
  import database
  if not database.user_has_thread_access(conn,usuario,hilo,write=True) :
    return None

  if database.thread_is_readonly(conn,hilo) :
    return pagina_error(path,usuario,"Este hilo es 'solo lectura'")

  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)
  texto=cuerpo.getfirst("texto")
  if not texto : # Incluye tanto el caso de vacio como de inexistente
    return pagina_error(path,usuario,"El Texto no puede estar vacio")

  error,texto2=parsers.convert_to_html(texto)
  if error :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},error)
  database.mensaje_add(conn,texto,texto2,usuario,hilo=hilo)
  return (302,{"Location":"/indice/%d" %metatag}, "")

