# $Id: parser.py 266 2007-07-11 21:19:25Z heimy $

import re

class Parser(object):
    def __init__(self):
        self.grammars = []
    def parse(self, strng):
        import grammars
        from grammars.nodes import NodeList, TextNode

        lst = NodeList()
        while strng:
            matches = sorted(grammars.get_matches(strng))
            if not matches:
                strng = ''
                continue
            match = matches[0]
            prev = strng[:match.beg]
            if prev:
                lst.append(TextNode(prev))
            lst.append(match.get_nodes(self))
            strng = strng[match.end:]
        return lst

if __name__ == '__main__':
    parser = Parser()
    nodelist = parser.parse('foobar! :) And this is [url="http://www.bold.com"][b]bold[/b][/url] foobar ;)')
    print nodelist.render_html()
