# $Id: parser_urls.py 472 2007-11-08 22:55:21Z alvaro $

# Everybody stand back!!!
domain = r"[a-zA-Z]{2,4}"
subdomain = r"(?:[a-zA-Z0-9_\-]+\.)+"
string = r"(?:[a-zA-Z0-9_\-]+)+"
port = r"(?:\:[0-9]+)?"
document = r"(?:/\S+)*"

allowed_urls = [
    '(?:http|ftp)://'+subdomain+domain+port+document+'/{0,1}',
    'mailto:'+string+"@"+subdomain+domain,
    ]

def url_o_matic(url):
  return """ <a href="%(url)s" title="%(url)s">%(url)s</a> """ % locals()

def parse(text, context = None):
  if context == "a" or context == "url" or context == "code":
    return len(text), text, None, [], None
  import re
  regexp = re.compile("|".join("(?:\s|\A)(%s)(?:\s|\Z)" % i for i in allowed_urls))
  ret = regexp.split(text,1)
  if len(ret) < 2:
    return len(text), text, None, [], None
  before = ret[0]
  url = url_o_matic(ret[1])
  after = "".join(i if i else "" for i in ret[2:])
  return len(before), before, ('TEXT', url), [], after

