# $Id: url_LOGIN.py 322 2007-08-01 14:15:29Z jcea $

from globales import monitor,openid_support,base_url

def gestiona_url(handler,path,usuario) :
  import database
  if path[0]=="LOGIN" :
    import cgi
    try:
      ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
      cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)
    except:
      import skins
      pagina = skins.Skin(path,usuario)
      if usuario:
        pagina.load_url(['error'])
        d = {"page_title": "cpif - ERROR",
             "generic_message": "<h2>ERROR<H2>\r\nYa logueado</h2>"
        }
      else:
        d = {"page_title": "cpif - LOGIN"}
      pagina.load_dict(d)
      return(pagina.web())
    path.pop(0)
    usuario_form=cuerpo.getfirst("usuario")
    clave_form=cuerpo.getfirst("clave")
    OpenID_form=cuerpo.getfirst("OpenID")
    if usuario_form and clave_form :
      @monitor
      def login(conn,usuario,clave) :
        return database.usuario_verifica(conn,nick=usuario,clave=clave)

      resultado=login(usuario_form,clave_form)
      if resultado :
        nick,cookie=resultado
        if cookie :
          cookie="cpif_auth=%s; path=/; expires=Wed, 01-Jan-2030 00:00:00 GMT;" %cookie
        return (302,{"Set-Cookie":cookie,"Location":"/"+"/".join(path)},"")
    elif openid_support and usuario_form and OpenID_form :
        @monitor
        def get_openid(conn,usuario,OpenID) :
          return database.get_openid(conn,usuario,OpenID)

        if get_openid(usuario_form,OpenID_form) :
          from openid.consumer import consumer
          from url_LOGIN_OpenID import sessions,create_new_state
          servidor=base_url+"/"
          rnd,sesion=create_new_state(usuario_form,"/"+"/".join(path))
          oidconsumer=consumer.Consumer(sesion,sessions)
          try :
            request = oidconsumer.begin(OpenID_form)
          except consumer.DiscoveryFailure, exc:
            return (200,{"Content-Type":"text/plain; charset=utf-8"},"Tenemos problemas con esa URL")
          else :
            if request is None :
              return (200,{"Content-Type":"text/plain; charset=utf-8"},"No encontramos ningun servicio OpenID en esa URL")
            if request.shouldSendRedirect() :
              redirect_url = request.redirectURL(servidor,servidor+"LOGIN_OpenID/%d" %rnd,immediate=False)
              return (302,{"Location":redirect_url},"")
            else :
              form_html = request.formMarkup(
                 servidor, servidor+"LOGIN_OpenID/%d" %rnd,
                 form_tag_attrs={'id':'openid_message'},
                 immediate=False)
              return (200,{"Content-Type":"text/html; charset=utf-8"},
"""<html><head><title>Transacci&oacutenOpenID transaction in progress</title></head>
<body onload='document.getElementById("%s").submit()'>
%s
</body></html>
"""%("openid_message",form_html))

  # Si no hemos salido antes, hay un error...
  import skins
  pagina = skins.Skin(["login_err"] + path,usuario)
  return (pagina.web())

