# $Id: url_edit_config.py 471 2007-11-08 22:37:42Z alvaro $

from globales import monitor
import globales

def gestiona_url(handler,path,usuario) :
  if len(path)!=1 : return None

  import skins
  pagina = skins.Skin(path,usuario)
  pagina.load_dict({"page_title": "cpif - Editar configuracion de CPIF"})

  if usuario!="master" :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h2>Solo el usuario 'master' puede editar la configuraci&oacute;n de CPIF</h2>"})
    return pagina.web()

  texto=['<tr><td>Number of messages per page on a thread</td><td><input type="text" name="thread_len" size="5" value="%d" /></td></tr>' %globales.thread_len]
  texto.append('<tr><td>Allow anonymous access?</td><td><input type="checkbox" name="allow_anonymous" %s /></td></tr>' % ("CHECKED" if globales.allow_anonymous else ""))
  texto.append('<tr><td>Allow private messaging between users?</td><td><input type="checkbox" name="allow_private_messages" %s /></td></tr>' % ("CHECKED" if globales.allow_private_messages else ""))
  texto.append('<tr><td>Simultaneous HTTP connections</td><td><input type="text" name="http_max_clients" size="5" value="%d" /></td></tr>' %globales.http_max_clients)
  texto.append('<tr><td>Specify initial HTTP timeout</td><td><input type="text" name="http_initial_timeout" size="5" value="%d" /></td></tr>' %globales.http_initial_timeout)
  texto.append('<tr><td>Keep-alive timeout<br/>(if zero or False, no keep-alive support)</td><td><input type="text" name="http_keep_alive_timeout" size="5" value="%d" /></td></tr>' %globales.http_keep_alive_timeout)

  texto.append('<tr><td>New Users Sign In</td><td><input type="radio" name="user_sign_in_mode" value="0" %s />Only "master" can create new users<br/>' %("CHECKED" if globales.user_sign_in_mode==0 else ""))
  texto.append('<input type="radio" name="user_sign_in_mode" value="1" %s />Users can sign in, but "master" must approve it<br/>' %("CHECKED" if globales.user_sign_in_mode==1 else ""))
  texto.append('<input type="radio" name="user_sign_in_mode" value="2" %s />Users can sign in freely</td></tr>' %("CHECKED" if globales.user_sign_in_mode==2 else ""))

  texto.append('<tr><td>OpenID Support<br/>(Requires library. See docs)</td><td><input type="checkbox" name="openid_support" %s /></td></tr>' % ("CHECKED" if globales.openid_support else ""))
  texto.append('<tr><td>Allow BBcode?</td><td><input type="checkbox" name="allow_bbcode" %s /></td></tr>' % ("CHECKED" if globales.allow_bbcode else ""))
  texto.append('<tr><td>Allow HTML?</td><td><input type="checkbox" name="allow_html" %s /></td></tr>' % ("CHECKED" if globales.allow_html else ""))
  texto.append('<tr><td>Allow avatar change<br/>(Requires library. See docs)</td><td><input type="checkbox" name="allow_avatar_change" %s /></td></tr>' % ("CHECKED" if globales.allow_avatar_change else ""))
  texto.append('<tr><td>Base URL for this service<br/>(<b>DO NOT</b> write down the last slash)</td><td><input type="text" name="base_url" size="50" value="%s" /></td></tr>' %globales.base_url)
  texto.append('<tr><td>TimeZone [<a href="http://www.timezoneconverter.com/">?</a>]</td><td><input type="text" name="tz" size="30" value="%s" /></td></tr>' %globales.tz)
  texto.append('<tr><td>Google\'s webmaster tools<br>Verification code</td><td><input type="text" name="google_verification" size="50" value="%s" /></td></tr>' %globales.google_verification)
  texto.append('<tr><td>Outgoing SMTP server</td><td><input type="text" name="smtp_server" size="30" value="%s" /></td><tr>' %globales.smtp_server)
  texto.append('<tr><td>Outgoing SMTP server port</td><td><input type="text" name="smtp_server_port" size="5" value="%d" /></td></tr>' %globales.smtp_server_port)
  texto.append('<tr><td>SMTP sender address</td><td><input type="text" name="smtp_email_sender" size="30" value="%s" /></td><tr>' %globales.smtp_email_sender)
  texto.append('<tr><td>Use TLS for SMTP</td><td><input type="checkbox" name="smtp_use_tls" %s /></td></tr>' % ("CHECKED" if globales.smtp_use_tls else ""))
  texto.append('<tr><td>Outgoing SMTP user<br/>(if server requires authentication)</td><td><input type="text" name="smtp_auth_user" size="25" value="%s" /></td><tr>' %globales.smtp_auth_user)
  texto.append('<tr><td>Outgoing SMTP password<br/>(if server requires authentication)</td><td><input type="password" name="smtp_auth_passwd" size="20" value="%s" /></td><tr>' %globales.smtp_auth_passwd)
  texto.append('<tr><td>CPIF Admin email address</td><td><input type="text" name="admin_email_address" size="30" value="%s" /></td><tr>' %globales.admin_email_address)

  return (200, {"Content-Type":"text/html; charset=utf-8"},
"""
<html>
<title>Editar configuraci&oacute;n de CPIF</title>
<body>
<form action="/edit_config_POST" method="post" enctype="multipart/form-data">
<table>
%s
<tr><td colspan="2" align="right"><input type="submit" name="submit" value="actualizar configuraci&oacute;n"/></td></tr>
</table>
</body>
</html>
""" % ("\r\n".join(texto)))

