# $Id: url_nuevo_hilo_POST.py 381 2007-10-11 15:39:16Z jcea $

from globales import monitor

import parsers # Doing here outside to avoid "monitor" deadlocks

def pagina_error(path,usuario,texto) :
  import skins
  pagina = skins.Skin(path,usuario)
  pagina.load_dict({"page_title": "Error"})
  pagina.load_url(["error"])
  pagina.load_dict({"generic_message": "<h1>%s</h1>" %texto})
  return pagina.web()

@monitor
def gestiona_url(conn,handler,path,usuario) :

  import database
  if len(path)!=2 : return None
  try :
    metatag=int(path[1])
  except :
    return None
  if not usuario : # Acceso anonimo
    return (302,{"Location":"/LOGIN/indice/%d" % metatag},"")
  if not database.user_has_metatag_access(conn,usuario,metatag,write=True) :
    return None

  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)
  titulo=cuerpo.getfirst("titulo")
  texto=cuerpo.getfirst("texto")
  if not (titulo and texto)  : # Incluye tanto el caso de vacios como de inexistentes
    return pagina_error(path,usuario,"El T&iacute;tulo y el Texto no pueden estar vacios")

  titulo=cgi.escape(titulo)

  error,texto2=parsers.convert_to_html(texto)
  if error :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},error)
  database.mensaje_add(conn,texto,texto2,usuario,titulo=titulo,metatags=(metatag,))
  return (302,{"Location":"/indice/%d" %metatag},"")

