# $Id: url_nuevo_hilo_privado_POST.py 397 2007-10-15 19:10:44Z jcea $

from globales import monitor

import parsers # Doing here outside to avoid "monitor" deadlocks

def pagina_error(path,usuario,texto) :
  import skins
  pagina = skins.Skin(path,usuario)
  pagina.load_dict({"page_title": "Error"})
  pagina.load_url(["error"])
  pagina.load_dict({"generic_message": "<h1>%s</h1>" %texto})
  return pagina.web()

@monitor
def gestiona_url(conn,handler,path,usuario) :
  from globales import allow_private_messages
  if not allow_private_messages : return None

  import database
  if len(path)!=1 : return None
  if not usuario : return None  # Acceso anonimo

  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)
  titulo=cuerpo.getfirst("titulo")
  texto=cuerpo.getfirst("texto")
  usuario_pedido_normalizado=cuerpo.getfirst("usuario_pedido_normalizado")
  if not (titulo and texto and usuario_pedido_normalizado)  : # Incluye tanto el caso de vacios como de inexistentes
    return pagina_error(path,usuario,"El T&iacute;tulo y el Texto no pueden estar vacios")

  root=conn.get_root()
  usuarios=root["usuarios"]["usuarios"]
  u=usuarios.get(usuario_pedido_normalizado)
  if not u :
    return None
  u2=usuarios.get(database.normaliza_nick(usuario))

  titulo=cgi.escape("[%s] %s" %(u["nick"],titulo))

  error,texto2=parsers.convert_to_html(texto)
  if error :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},error)
  num_thread,dummy=database.mensaje_add(conn,texto,texto2,usuario,titulo=titulo,metatags=(u2["metatag_privado"],u["metatag_privado"]))
  database.toggle_monitor_thread(conn,usuario,num_thread)
  database.toggle_monitor_thread(conn,usuario_pedido_normalizado,num_thread)
  return (302,{"Location":"/indice/%s" %u2["metatag_privado"]},"")

